


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/servers/socksplugins/smtp.py: 12%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/servers/socksplugins/smtp.py</b> :
            <span class="pc_cov">12%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            93 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">15 run</span>
            <span class="mis shortkey_m button_toggle_mis">78 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="stm run hide_run"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="pln"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm mis"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="stm mis"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="stm mis"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="stm mis"><a href="#n72">72</a></p>
<p id="n73" class="stm mis"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="stm mis"><a href="#n75">75</a></p>
<p id="n76" class="stm mis"><a href="#n76">76</a></p>
<p id="n77" class="pln"><a href="#n77">77</a></p>
<p id="n78" class="stm mis"><a href="#n78">78</a></p>
<p id="n79" class="stm mis"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="stm mis"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="stm mis"><a href="#n86">86</a></p>
<p id="n87" class="stm mis"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="stm mis"><a href="#n89">89</a></p>
<p id="n90" class="stm mis"><a href="#n90">90</a></p>
<p id="n91" class="stm mis"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="stm mis"><a href="#n94">94</a></p>
<p id="n95" class="stm mis"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="stm mis"><a href="#n97">97</a></p>
<p id="n98" class="stm mis"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="stm mis"><a href="#n101">101</a></p>
<p id="n102" class="pln"><a href="#n102">102</a></p>
<p id="n103" class="stm mis"><a href="#n103">103</a></p>
<p id="n104" class="stm mis"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="stm mis"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="stm mis"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="stm mis"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="stm mis"><a href="#n118">118</a></p>
<p id="n119" class="stm mis"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="pln"><a href="#n121">121</a></p>
<p id="n122" class="stm run hide_run"><a href="#n122">122</a></p>
<p id="n123" class="stm mis"><a href="#n123">123</a></p>
<p id="n124" class="stm mis"><a href="#n124">124</a></p>
<p id="n125" class="stm mis"><a href="#n125">125</a></p>
<p id="n126" class="pln"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="stm mis"><a href="#n128">128</a></p>
<p id="n129" class="stm mis"><a href="#n129">129</a></p>
<p id="n130" class="pln"><a href="#n130">130</a></p>
<p id="n131" class="pln"><a href="#n131">131</a></p>
<p id="n132" class="stm mis"><a href="#n132">132</a></p>
<p id="n133" class="stm mis"><a href="#n133">133</a></p>
<p id="n134" class="stm mis"><a href="#n134">134</a></p>
<p id="n135" class="stm mis"><a href="#n135">135</a></p>
<p id="n136" class="stm mis"><a href="#n136">136</a></p>
<p id="n137" class="stm mis"><a href="#n137">137</a></p>
<p id="n138" class="stm mis"><a href="#n138">138</a></p>
<p id="n139" class="stm mis"><a href="#n139">139</a></p>
<p id="n140" class="stm mis"><a href="#n140">140</a></p>
<p id="n141" class="pln"><a href="#n141">141</a></p>
<p id="n142" class="stm mis"><a href="#n142">142</a></p>
<p id="n143" class="stm mis"><a href="#n143">143</a></p>
<p id="n144" class="stm mis"><a href="#n144">144</a></p>
<p id="n145" class="stm mis"><a href="#n145">145</a></p>
<p id="n146" class="stm mis"><a href="#n146">146</a></p>
<p id="n147" class="pln"><a href="#n147">147</a></p>
<p id="n148" class="pln"><a href="#n148">148</a></p>
<p id="n149" class="stm mis"><a href="#n149">149</a></p>
<p id="n150" class="stm mis"><a href="#n150">150</a></p>
<p id="n151" class="pln"><a href="#n151">151</a></p>
<p id="n152" class="stm mis"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="pln"><a href="#n154">154</a></p>
<p id="n155" class="stm run hide_run"><a href="#n155">155</a></p>
<p id="n156" class="stm mis"><a href="#n156">156</a></p>
<p id="n157" class="stm mis"><a href="#n157">157</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># A Socks Proxy for the SMTP Protocol</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Dirk-jan Mollema (@_dirkjan) / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#  A simple SOCKS server that proxies a connection to relayed SMTP connections</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run"><span class="key">import</span> <span class="nam">base64</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">examples</span><span class="op">.</span><span class="nam">ntlmrelayx</span><span class="op">.</span><span class="nam">servers</span><span class="op">.</span><span class="nam">socksserver</span> <span class="key">import</span> <span class="nam">SocksRelay</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="com"># Besides using this base class you need to define one global variable when</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln"><span class="com"># writing a plugin:</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="nam">PLUGIN_CLASS</span> <span class="op">=</span> <span class="str">"SMTPSocksRelay"</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="nam">EOL</span> <span class="op">=</span> <span class="str">'\r\n'</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">class</span> <span class="nam">SMTPSocksRelay</span><span class="op">(</span><span class="nam">SocksRelay</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">    <span class="nam">PLUGIN_NAME</span> <span class="op">=</span> <span class="str">'SMTP Socks Plugin'</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="nam">PLUGIN_SCHEME</span> <span class="op">=</span> <span class="str">'SMTP'</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">socksSocket</span><span class="op">,</span> <span class="nam">activeRelays</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">        <span class="nam">SocksRelay</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">targetHost</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">socksSocket</span><span class="op">,</span> <span class="nam">activeRelays</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span> <span class="op">=</span> <span class="num">8192</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="op">@</span><span class="nam">staticmethod</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln">    <span class="key">def</span> <span class="nam">getProtocolPort</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">        <span class="key">return</span> <span class="num">25</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getServerEhlo</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="key">for</span> <span class="nam">key</span> <span class="key">in</span> <span class="nam">list</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">.</span><span class="nam">keys</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">            <span class="key">if</span> <span class="nam">key</span> <span class="op">!=</span> <span class="str">'data'</span> <span class="key">and</span> <span class="nam">key</span> <span class="op">!=</span> <span class="str">'scheme'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">                <span class="key">if</span> <span class="str">'protocolClient'</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">key</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">                    <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">key</span><span class="op">]</span><span class="op">[</span><span class="str">'protocolClient'</span><span class="op">]</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">ehlo_resp</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">    <span class="key">def</span> <span class="nam">initConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">    <span class="key">def</span> <span class="nam">skipAuthentication</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'220 Microsoft ESMTP MAIL Service ready'</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">        <span class="com"># Next should be the client sending the EHLO command</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">        <span class="nam">cmd</span><span class="op">,</span> <span class="nam">params</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">recvPacketClient</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">' '</span><span class="op">,</span><span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm mis">        <span class="key">if</span> <span class="nam">cmd</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'EHLO'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">            <span class="nam">clientcapabilities</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getServerEhlo</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'\n'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln">            <span class="com"># Don't offer these AUTH options so the client won't use them</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln">            <span class="com"># also don't offer STARTTLS since that will break things</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">            <span class="nam">blacklist</span> <span class="op">=</span> <span class="op">[</span><span class="str">'X-EXPS GSSAPI NTLM'</span><span class="op">,</span> <span class="str">'STARTTLS'</span><span class="op">,</span> <span class="str">'AUTH NTLM'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="key">for</span> <span class="nam">cap</span> <span class="key">in</span> <span class="nam">blacklist</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">                <span class="key">if</span> <span class="nam">cap</span> <span class="key">in</span> <span class="nam">clientcapabilities</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm mis">                    <span class="nam">clientcapabilities</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">cap</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln">            <span class="com"># Offer PLAIN auth for specifying the username</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">            <span class="key">if</span> <span class="str">'AUTH PLAIN'</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">clientcapabilities</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">                <span class="nam">clientcapabilities</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="str">'AUTH PLAIN'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">            <span class="com"># Offer LOGIN for specifying the username</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">            <span class="key">if</span> <span class="str">'AUTH LOGIN'</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">clientcapabilities</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">                <span class="nam">clientcapabilities</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="str">'AUTH LOGIN'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'SMTP: Sending mirrored capabilities from server: %s'</span> <span class="op">%</span> <span class="str">', '</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">clientcapabilities</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">            <span class="com"># Prepare capabilities</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">            <span class="nam">delim</span> <span class="op">=</span> <span class="nam">EOL</span><span class="op">+</span><span class="str">'250-'</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm mis">            <span class="nam">caps</span> <span class="op">=</span> <span class="nam">delim</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">clientcapabilities</span><span class="op">[</span><span class="op">:</span><span class="op">-</span><span class="num">1</span><span class="op">]</span><span class="op">)</span> <span class="op">+</span> <span class="nam">EOL</span> <span class="op">+</span> <span class="str">'250 '</span> <span class="op">+</span> <span class="nam">clientcapabilities</span><span class="op">[</span><span class="op">-</span><span class="num">1</span><span class="op">]</span> <span class="op">+</span> <span class="nam">EOL</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'250-%s'</span> <span class="op">%</span> <span class="nam">caps</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'SMTP: Socks plugin expected EHLO command, but got: %s %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">cmd</span><span class="op">,</span> <span class="nam">params</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="pln">        <span class="com"># next</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm mis">        <span class="nam">cmd</span><span class="op">,</span> <span class="nam">params</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">recvPacketClient</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">' '</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm mis">        <span class="nam">args</span> <span class="op">=</span> <span class="nam">params</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">' '</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">        <span class="key">if</span> <span class="nam">cmd</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'AUTH'</span> <span class="key">and</span> <span class="nam">args</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="op">==</span> <span class="str">'LOGIN'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln">            <span class="com"># OK, ask for their username</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'334 VXNlcm5hbWU6'</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">            <span class="com"># Client will now send their AUTH</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">            <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln">            <span class="com"># This contains base64(username), decode</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm mis">            <span class="nam">creds</span> <span class="op">=</span> <span class="nam">base64</span><span class="op">.</span><span class="nam">b64decode</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">strip</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="op">=</span> <span class="nam">creds</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln">            <span class="com"># Client will now send the password, we don't care for it but receive it anyway</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'334 UGFzc3dvcmQ6'</span><span class="op">+</span><span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm mis">            <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm mis">        <span class="key">elif</span> <span class="nam">cmd</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'AUTH'</span> <span class="key">and</span> <span class="nam">args</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="op">==</span> <span class="str">'PLAIN'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">            <span class="com"># Simple login</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">            <span class="com"># This contains base64(\x00username\x00password), decode and split</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm mis">            <span class="nam">creds</span> <span class="op">=</span> <span class="nam">base64</span><span class="op">.</span><span class="nam">b64decode</span><span class="op">(</span><span class="nam">args</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">.</span><span class="nam">strip</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="op">=</span> <span class="nam">creds</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'\x00'</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'SMTP: Socks plugin expected AUTH PLAIN or AUTH LOGIN command, but got: %s %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">cmd</span><span class="op">,</span> <span class="nam">params</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln">        <span class="com"># Check if we have a connection for the user</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="pln">            <span class="com"># Check the connection is not inUse</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm mis">            <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">]</span><span class="op">[</span><span class="str">'inUse'</span><span class="op">]</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'SMTP: Connection for %s@%s(%s) is being used at the moment!'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln">                    <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm mis">                <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'SMTP: Proxying client session for %s@%s(%s)'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln">                    <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">activeRelays</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">]</span><span class="op">[</span><span class="str">'protocolClient'</span><span class="op">]</span><span class="op">.</span><span class="nam">session</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">'SMTP: No session for %s@%s(%s) available'</span> <span class="op">%</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln">                <span class="nam">self</span><span class="op">.</span><span class="nam">username</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln">        <span class="com"># We arrived here, that means all is OK</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'235 2.7.0 Authentication successful%s'</span> <span class="op">%</span> <span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">sock</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocketFile</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">session</span><span class="op">.</span><span class="nam">file</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm run hide_run">    <span class="key">def</span> <span class="nam">tunnelConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm mis">        <span class="nam">doneIndicator</span> <span class="op">=</span> <span class="nam">EOL</span><span class="op">+</span><span class="str">'.'</span><span class="op">+</span><span class="nam">EOL</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm mis">        <span class="key">while</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm mis">            <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="pln">            <span class="com"># If this returns with an empty string, it means the socket was closed</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">            <span class="key">if</span> <span class="nam">data</span> <span class="op">==</span> <span class="str">''</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="stm mis">                <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm mis">            <span class="nam">info</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">strip</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">' '</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="pln">            <span class="com"># See if a QUIT command was sent, in which case we want to close</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="pln">            <span class="com"># the connection to the client but keep the relayed connection alive</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm mis">            <span class="key">if</span> <span class="nam">info</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'QUIT'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Client sent QUIT command, closing socks connection to client'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="str">'221 2.0.0 Service closing transmission channel%s'</span> <span class="op">%</span> <span class="nam">EOL</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="stm mis">                <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="stm mis">            <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm mis">            <span class="key">if</span> <span class="nam">info</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">.</span><span class="nam">upper</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'DATA'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'SMTP Socks entering DATA transfer mode'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="pln">                <span class="com"># DATA transfer, forward to the server till done</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm mis">                <span class="key">while</span> <span class="nam">data</span><span class="op">[</span><span class="op">-</span><span class="num">5</span><span class="op">:</span><span class="op">]</span> <span class="op">!=</span> <span class="nam">doneIndicator</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm mis">                    <span class="nam">prevdata</span> <span class="op">=</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm mis">                    <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm mis">                    <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">5</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="pln">                        <span class="com"># This can happen, the .CRLF will be in a packet after the first CRLF</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="pln">                        <span class="com"># we stitch them back together for analysis</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm mis">                        <span class="nam">data</span> <span class="op">=</span> <span class="nam">prevdata</span> <span class="op">+</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'SMTP Socks DATA transfer mode finished'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="pln">                <span class="com"># DATA done, forward server reply</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm mis">                <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">relaySocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">send</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm run hide_run">    <span class="key">def</span> <span class="nam">recvPacketClient</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm mis">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">.</span><span class="nam">recv</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">packetSize</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm mis">        <span class="key">return</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
